* ZZError.prg
* zzFox.prg, Execute FoxPro Commands from
* a .DOT prompt style window
*

* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
  RETURN
ENDIF

PRIVATE cConsole,cDevice,cPrint,cWinSave,cChoice,nKey, ;
        cLine,cEhSave,bOWVis,cTalk,n,nArea,cMemory,cStatus

IF SET('TALK') = 'ON'
  SET TALK OFF
  cTalk = 'ON'
ELSE
  cTalk = 'OFF'
ENDIF

cEhSave = ON('ERROR')
ON ERROR
cConsole = SET('CONSOLE')
cDevice  = SET('DEVICE')
cPrint   = SET('PRINTER')
SET CONSOLE ON
SET PRINT OFF
SET DEVICE TO SCREEN
cWinSave = WOUTPUT()
bOWVis = WVISIBLE(cWinSave)
PUSH KEY CLEAR

SET CONSOLE ON
SET PRINT OFF
SET DEVICE TO SCREEN

ON ERROR WAIT 'Invalid command, try again.' WINDOW TIMEOUT 1.5

DEFINE WINDOW cmd FROM 0,0 TO SROWS() - 4, 72 ;
   FLOAT GROW SYSTEM MINIMIZE ;
   TITLE 'Enter FoxPro commands   "RESU" = Resume'
ACTIVATE WINDOW cmd
  
DO WHILE .t.
  cCMD = ''
  ACCEPT '. ' TO cCMD
  cCMD = UPPER(cCMD)
  DO CASE
  CASE EMPTY(cCMD)
    WAIT 'No command entered, try again.' WINDOW TIMEOUT 1.5
    LOOP
  CASE ALLTRIM(cCMD) = 'SUSP'
    ON ERROR WAIT '"Suspend" not allowed here, try again' WINDOW TIMEOUT 1.5
    SUSP
    ON ERROR WAIT 'Invalid command, try again.' WINDOW TIMEOUT 1.5
    LOOP
  CASE ALLTRIM(cCMD) = 'CANC'
    WAIT '"Cancel" not allowed here, cancel from SalesBridge menu.' WINDOW TIMEOUT 1.5
    LOOP
  CASE ALLTRIM(cCMD) = 'QUIT'
    WAIT '"Quit" not allowed here, quit from SalesBridge menu.' WINDOW TIMEOUT 1.5
    LOOP
  CASE EMPTY(cCMD) OR ALLTRIM(cCMD) = 'RESU' ;
       OR ALLTRIM(cCMD) = 'RETURN'
    WAIT 'SalesBridge will re-start now....' WINDOW TIMEOUT 1.5
    EXIT
  OTHERWISE
    * Execute the command
    &cCMD
  ENDCASE
ENDDO {.t.}

ON ERROR DO zzerror WITH ERROR(),MESSAGE(),PROGRAM(),MESSAGE(1),LINENO(1)

* ReStart (warm boot entire app)
DO RESTENV            && restore environment
SET CONSOLE ON        && set up initial conditions for "warm boot"
SET PRINT OFF
SET DEVICE TO SCREEN
CLOSE DATABASES
SET EXCLUSIVE OFF     && assuming this is a multiuser app
CLEAR WINDOWS
CLEAR POPUPS
CLEAR READ ALL        && cancel all READs, including foundation READ

* (to re-paint main Fox screen and exit main loop in zz.prg)
_SvWall = 'exit' + _Wall

cACTION = 'RETURN TO MASTER'
RETURN

* eof - main procedure zzerror
***************************************************************
FUNCTION LOCKF
* Not used as of 11/94 pds, save for future use
*    This function attempts to lock the current table.  The user is prompted
*    if the table cannot be locked.
*

IF FLOCK()
  RETURN .t.
ENDIF
PRIVATE nInKey
DO zzalert WITH 'INFO','',-1,-1, ;
              [ File "] + DBF() + [" in use...], ;
              "Waiting for access, Press [Esc] to cancel"
CLEAR TYPEAHEAD
nInKey = INKEY(1)
DO WHILE nInKey <> 27 AND (NOT FLOCK())
  nInKey = INKEY(1)
ENDDO
RELEASE WINDOW zzalert
RETURN nInKey <> 27

* eof - lockf
***************************************************************
FUNCTION LOCKR
* Not used as of 11/94 pds, save for future use
*
*    This function will attempt to lock the current record in the current
*    table.  The user is prompted if the record cannot be locked.
*
IF RLOCK()
  RETURN .t.
ENDIF
PRIVATE nInKey
DO zzalert WITH 'INFO','',-1,-1, ;
              [Record in file "] + DBF() + [" in use...], ;
              '   Waiting for access, Press [Esc] to cancel'
CLEAR TYPEAHEAD
nInKey = INKEY(1)
DO WHILE nInKey <> 27 AND (NOT RLOCK())
  nInKey = INKEY(1)
ENDDO
RELEASE WINDOW zzalert
RETURN nInKey <> 27

* eof - lockr
***************************************************************
PROCEDURE RESTENV
* Not used as of 11/94 pds, save for future use
*
* called by error handler to restore environment in existence before error
* handler was invoked

SET CONSOLE &cConsole
SET DEVICE TO &cDevice
SET PRINT &cPrint
RELEASE WINDOW cmd
IF EMPTY(cWinSave)
  ACTIVATE SCREEN
ELSE
  IF bOWVis
    ACTIVATE WINDOW (cWinSave) SAME
  ELSE
    ACTIVATE WINDOW (cWinSave) SAME NOSHOW
  ENDIF
ENDIF
POP KEY
IF ON('ERROR') <> cEhSave
  ON ERROR &cEhSave
ENDIF
IF cTalk = 'ON'
  SET TALK ON
ENDIF

RETURN

*EOF - restenv
***************************************************************
***************************************************************
***************************************************************
*EOF - zzFox.prg
