* ZZqfilt.prg
* SalesBridge quick filter/query list
*

PARAMETERS cwintitle


#REGION 1

* Don't interfere with calling task's variables.
PRIVATE ALL EXCEPT _*

cOption = ""

DO wModalRead with "read1()"

RETURN

* EOF - Procedure zzFind
***********************************************************
FUNCTION read1
*
* Main gets/read for zzfind.prg
*

*********
#REGION 0
REGIONAL m.currarea, m.talkstat, m.compstat

IF SET("TALK") = "ON"
	SET TALK OFF
	m.talkstat = "ON"
ELSE
	m.talkstat = "OFF"
ENDIF
m.compstat = SET("COMPATIBLE")
SET COMPATIBLE FOXPLUS

IF NOT WEXIST("qFilt") 
  DEFINE WINDOW qFilt ;
	AT  0.000, 0.000  ;
	SIZE 17,90 ;
	TITLE ' ' + cWinTitle  ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	FLOAT ;
	NOCLOSE ;
	SHADOW ;
	NOMINIMIZE ;
	DOUBLE
  MOVE WINDOW qFilt CENTER
ENDIF

*********
#REGION 1
IF WVISIBLE("qFilt")
	ACTIVATE WINDOW qFilt SAME
ELSE
	ACTIVATE WINDOW qFilt NOSHOW
ENDIF


qFiltList = space(80)

@  1, 1 SAY 'Select filter from this pull-down list.'
@  3, 1 GET qFiltList ;
	PICTURE "@^" ;
	FROM _zzFilt ;
	SIZE 1.538,84 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;

@ WROWS() -3,23 GET cOption ;
	PICTURE "@*HT \<OK; Cancel" ;
	SIZE 2,12,8 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;

IF NOT WVISIBLE("qFilt")
	ACTIVATE WINDOW qFilt
ENDIF

READ CYCLE MODAL

* place chosen filter into report filter memvar
IF NOT EMPTY(qFiltList) AND cOption = 'OK'
  IF NOT USED('zzFilt')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzFilt','DBF','Where is the Filter file?'));
        IN 0 AGAIN ALIAS zzFilt
  ENDIF
  SELECT zzFilt
  SET INDEX TO zzFilt
  SET ORDER TO 1

  SEEK UPPER(qFiltList)

  * Limit user to "owned" records if required

  * Add something like [owner='JFK' AND ]
  * to the begining of the filter string
  * if limiting user access to not all records

  IF _Ok2All
    _filt = zzFilt->FiltStr
    _FiltDesc = ALLTRIM(qFiltList)
  ELSE
    _filt = 'owner=[' +_Owner + '] AND ' + ALLTRIM(zzFilt->FiltStr)
    _FiltDesc = '( Owner = ' + _Owner + ') ' + ALLTRIM(qFiltList)
  ENDIF
  
  DEACTIVATE WINDOW "Customer_List"
ELSE
  * do nothing if user pick blank filter
ENDIF

RELEASE WINDOW qFilt

#REGION 0
IF m.talkstat = "ON"
	SET TALK ON
ENDIF
IF m.compstat = "ON"
	SET COMPATIBLE ON
ENDIF

RETURN

* EOF - FUNCTION read1

****************************************************
****************************************************
* EOF - zzqFilt.prg
****************************************************
****************************************************